"""
Problem 2 Zukei Puzzle
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob2_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob2_out.txt"
OUT_FILE = None

X = 0
Y = 1

def main():
    numberOfInputs = int(nextLine())
    #print(numberOfInputs)
    for case in range(1, numberOfInputs+1):
        puzzleInfo = nextLine().split()
        numberOfPts = int(puzzleInfo[0])
        ptList = []
        index = 1
        for count in range(numberOfPts):
            ptList.append([int(puzzleInfo[index]), int(puzzleInfo[index+1])])
            index += 2
        #print("Case",case, "ptList", ptList)
        ptList.sort()
        vertLineSegments = []
        for startIndex in range(0, numberOfPts-1):
            xStart = ptList[startIndex][X]
            yStart = ptList[startIndex][Y]
            testIndex = startIndex + 1
            while testIndex < numberOfPts and ptList[testIndex][X] == xStart:
                vertLineSegments.append([yStart, ptList[testIndex][Y], xStart])
                testIndex += 1
        #print("Case",case, "vertLineSegments", vertLineSegments)
        vertLineSegments.sort()
        #print("Case",case, "vertLineSegments", vertLineSegments)

        for testIndex in range(len(vertLineSegments)-1):
            if vertLineSegments[testIndex][0] == vertLineSegments[testIndex+1][0] and \
               vertLineSegments[testIndex][1] == vertLineSegments[testIndex+1][1]:
                break
            
        
        resultStr = "Case " + str(case) + ":"
        resultStr += " " + str(vertLineSegments[testIndex][2]) + " " + str(vertLineSegments[testIndex][0])
        resultStr += " " + str(vertLineSegments[testIndex+1][2]) + " " + str(vertLineSegments[testIndex+1][0])
        resultStr += " " + str(vertLineSegments[testIndex][2]) + " " + str(vertLineSegments[testIndex][1])
        resultStr += " " + str(vertLineSegments[testIndex+1][2]) + " " + str(vertLineSegments[testIndex+1][1])
        writeLine(resultStr)

    if WRITE_FILE:
        OUT_FILE.close()

def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip()
    else:
        line = input()
    return line
            

main()
