import java.util.*;

public class EggHunt_1
{
    public static void main( String[] args )
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            ArrayList<Integer> positions = new ArrayList<>();
            int curr = scan.nextInt();
            int numEggs = scan.nextInt();
            for ( int e = 0; e < numEggs; e++ )
                positions.add( scan.nextInt() );

            System.out.print( "Case " + c + ":" );
            while ( !positions.isEmpty() )
            {
                int leastPos = -1;
                int leastDiff = Integer.MAX_VALUE;
                for ( int i = 0; i < positions.size(); i++ )
                {
                    int difference = Math.abs( curr - positions.get( i ) );
                    if ( difference < leastDiff )
                    {
                        leastDiff = difference;
                        leastPos = i;
                    }
                }
                System.out.print( " " + positions.get( leastPos ) );
                curr = positions.get( leastPos );
                positions.remove( leastPos );
            }
            System.out.println();
        }

        scan.close();
    }

}
