import java.util.Scanner;

public class Golf_4
{
    private final double baseUnit = 5.625;
    
    // This is no fun at all; you do what you have to do.
    private final String[] right = { "N", "NtE", "NbE", "NNEtN", "NNE", "NNEtE",
                                     "NEbN", "NEtN", "NE", "NEtE", "NEbE",
                                     "ENEtN",
                                     "ENE", "ENEtE", "EbN", "EtN", "E" };

    private final String[] left = { "N", "NtW", "NbW", "NNWtN", "NNW", "NNWtW",
                                    "NWbN", "NWtN", "NW", "NWtW", "NWbW",
                                    "WNWtN",
                                    "WNW", "WNWtW", "WbN", "WtN", "W" };

    public static void main( String[] args )
    {
        Golf_4 g4 = new Golf_4();
        g4.solve();
    }

    private void solve()
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            System.out.printf( "Case %d: ", c );
            int degrees = scan.nextInt();
            String[] input = scan.nextLine().split( "\\s+" );
            String dir = input[input.length - 1];
            if ( dir.equals( "right" ) )
                System.out.println( findClosest( degrees, right ) );
            else
                System.out.println( findClosest( degrees, left ) );
        }
        scan.close();
    }

    private String findClosest( int degrees, String[] dirs )
    {
        int d = 0;
        while ( degrees > d * baseUnit )
            d++ ;

        if ( degrees == d * baseUnit )
            return dirs[d];
        else // degrees < d * 5
        {
            double diff1 = d * baseUnit - degrees;
            double diff2 = degrees - ( d - 1 ) * baseUnit;
            if ( diff1 < diff2 )
                return dirs[d];
            else
                return dirs[d - 1];
        }
    }
}
