import java.util.*;

public class Wander_8
{
    private HashMap<Integer, Long> solutions = new HashMap<>();

    public static void main( String[] args )
    {
        Wander_8 wander = new Wander_8();
        wander.solve();
    }

    private void solve()
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            int val = scan.nextInt();
            System.out.printf( "Case %d: %d\n", c, getSolution( val ) );
        }
        scan.close();
    }

    private long getSolution( int val )
    {
        if ( val <= -3 )
            return val;
        else if ( val < 3 )
            return 2 * val;
        else if ( solutions.containsKey( val ) )
            return solutions.get( val );
        else
        {
            long answer = getSolution( val - 6 ) + getSolution( val - 4 ) +
                          getSolution( val - 1 );
            solutions.put( val, answer );
            return answer;
        }
    }
}
