"""
Problem 1 Good Hunting
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob1_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob1_out.txt"
OUT_FILE = None



def main():
    numberOfInputs = int(nextLine())
    for case in range(1, numberOfInputs+1):
        huntInfo = nextLine().split()
        startPos = int(huntInfo[0])
        numberOfEggs = int(huntInfo[1])
        eggPosList = []
        index = 2
        for count in range(numberOfEggs):
            eggPosList.append(int(huntInfo[index]))
            index += 1
        eggPosList.sort()
        foundPosList = []
        if numberOfEggs > 0:
            closestIndex = 0
            currentPos = startPos
            closestDist = abs(currentPos - eggPosList[0])
            for testIndex in range(1,numberOfEggs):
                testDist = abs(currentPos - eggPosList[testIndex])
                if closestDist > testDist:
                    closestIndex = testIndex
                    closestDist = testDist
            currentPos = eggPosList[closestIndex]
            foundPosList.append(eggPosList[closestIndex])
            eggPosList.pop(closestIndex)
            numberOfEggs -= 1
            for count in range(numberOfEggs):
                if closestIndex == 0:
                    pass
                elif closestIndex == numberOfEggs:
                    closestIndex -= 1
                elif abs(currentPos - eggPosList[closestIndex-1]) < abs(currentPos - eggPosList[closestIndex]):
                    closestIndex = closestIndex - 1
                elif abs(currentPos - eggPosList[closestIndex-1]) == abs(currentPos - eggPosList[closestIndex]):
                    raise ValueError("equal distance eggs")
                currentPos = eggPosList[closestIndex]
                foundPosList.append(eggPosList[closestIndex])
                eggPosList.pop(closestIndex)
                numberOfEggs -= 1
        resultStr = "Case " + str(case) + ":"
        for pos in foundPosList:
            resultStr += " " + str(pos)
        writeLine(resultStr)

    if WRITE_FILE:
        OUT_FILE.close()

def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip()
    else:
        line = input()
    return line
            

main()
